VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTooltip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'====================================================================='
' Member Variables
'====================================================================='

Private m_lngHwnd               As Long
Private m_lngMaxWidth           As Long

'====================================================================='
' Properties
'====================================================================='

Public Property Get MaxWidth() As Long

    Width = m_lngMaxWidth

End Property

Public Property Let MaxWidth(lngMaxWidth As Long)

    m_lngMaxWidth = lngMaxWidth
    SendMessageLong m_lngHwnd, TTM_SETMAXTIPWIDTH, 0, m_lngMaxWidth

End Property

Public Property Get VisibleTime() As Long

    VisibleTime = SendMessageLong(m_lngHwnd, TTM_GETDELAYTIME, TTDT_AUTOPOP, 0)

End Property

Public Property Let VisibleTime(lngTime As Long)

    If lngTime > 32767 Then lngTime = 32767
    If lngTime < 0 Then lngTime = 0
    
    SendMessageLong m_lngHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, lngTime

End Property

Public Property Get DelayTime() As Long

    DelayTime = SendMessageLong(m_lngHwnd, TTM_GETDELAYTIME, TTDT_INITIAL, 0)

End Property

Public Property Let DelayTime(lngTime As Long)

    If lngTime > 32767 Then lngTime = 32767
    If lngTime < 0 Then lngTime = 0
    
    SendMessageLong m_lngHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, lngTime

End Property



'====================================================================='
' Methods
'====================================================================='

Public Sub Create(lngHwndParent As Long)

    m_lngHwnd = CreateWindowEx(0, _
                               "tooltips_class32", _
                               0, _
                               TTS_NOPREFIX Or TTS_ALWAYSTIP, _
                               CW_USEDEFAULT, _
                               CW_USEDEFAULT, _
                               CW_USEDEFAULT, _
                               CW_USEDEFAULT, _
                               lngHwndParent, _
                               0, _
                               App.hInstance, _
                               0)
    
    SendMessageLong m_lngHwnd, TTM_SETMAXTIPWIDTH, 0, m_lngMaxWidth

End Sub

Public Sub Destroy()

    DestroyWindow m_lngHwnd
    
End Sub

Public Sub AddControl(ctlTool As Object, strCaption As String, Optional blnCenterTip As Boolean = False)

    Dim udtToolInfo As TOOLINFO
    
    With udtToolInfo
    
        GetClientRect ctlTool.hwnd, .cRect
        .hwnd = ctlTool.hwnd
        
        .uFlags = TTF_IDISHWND Or TTF_SUBCLASS
        If blnCenterTip Then
            .uFlags = .uFlags Or TTF_CENTERTIP
        End If
        
        .uId = ctlTool.hwnd
        .lpszText = strCaption
        .cbSize = Len(udtToolInfo)
        
    End With
    
    SendMessage m_lngHwnd, TTM_ADDTOOL, 0, udtToolInfo
    
End Sub


'====================================================================='
' Events
'====================================================================='

Private Sub Class_Initialize()

    m_lngMaxWidth = 300

End Sub
